/****************************************************************************
*
* 1995 (C) Unpublished Copyright Novell, Inc. All Rights Reserved.
*
* No part of this file may be duplicated, revised, translated,
* localized or modified in any manner or compiled, linked or 
* uploaded or downloaded to or from any computer system without
* the prior written consent of Novell, Inc.
*
*****************************************************************************/

#if !defined(NOVELL_LSAPI_INCLUDED)
#define NOVELL_LSAPI_INCLUDED

#ifdef WIN95
#ifndef WIN32
#define WIN32
#endif
#ifndef _WINDOWS
#define _WINDOWS
#endif
#endif

#ifdef MSWIN
#ifndef _WINDOWS
#define _WINDOWS
#endif
#endif


#ifdef _WINDOWS
#include <windows.h>
#endif

#if defined(WINAPI)
#ifdef WIN32
#ifdef _MSC_VER
#ifdef EXPORT_NLS
#define N_LSAPI_FUNCDEF __declspec(dllexport) WINAPI
#else
#define N_LSAPI_FUNCDEF __declspec(dllimport) WINAPI
#endif // #ifdef EXPORT_NLS
#else
#ifdef EXPORT_NLS
#define N_LSAPI_FUNCDEF WINAPI _export
#else
#define N_LSAPI_FUNCDEF WINAPI _import
#endif // #ifdef EXPORT_NLS
#endif // #ifdef _MSC_VER 
#else
#ifdef EXPORT_NLS
#define N_LSAPI_FUNCDEF WINAPI _export
#else
#define N_LSAPI_FUNCDEF WINAPI
#endif
#endif // #ifdef WIN32
#else
#define N_LSAPI_FUNCDEF
#endif // #ifdef WINAPI

#if !defined(FAR)
#define FAR
#endif

// Error code defines

#define LS_SUCCESS                                                              0x0
#define LS_BAD_HANDLE                     0xc0001001
#define LS_INSUFFICIENT_UNITS             0xc0001002
#define LS_SYSTEM_UNAVAILABLE             0xc0001003
#define LS_LICENSE_TERMINATED             0xc0001004
#define LS_AUTHORIZATION_UNAVAILABLE            0xc0001005
#define LS_LICENSE_UNAVAILABLE            0xc0001006
#define LS_RESOURCES_UNAVAILABLE          0xc0001007
#define LS_NETWORK_UNAVAILABLE            0xc0001008
#define LS_TEXT_UNAVAILABLE               0x80001009
#define LS_UNKNOWN_STATUS                 0xc000100a
#define LS_BAD_INDEX                      0xc000100b
#define LS_LICENSE_EXPIRED                0x8000100c
#define LS_BUFFER_TOO_SMALL               0xc000100d
#define LS_BAD_ARG                        0xc000100e

#define NLS_TOO_MANY_UNITS                                              0x80004001
#define NLS_ALREADY_INSTALLED                                   0xC0004002

// definitions for LSQuery()
#define LS_INFO_NONE                      0x0
#define LS_INFO_SYSTEM                    0x1
#define LS_INFO_DATA                      0x2
#define LS_UPDATE_PERIOD                  0x3

// Type definitions
#define INT32           long
#define UINT32          unsigned long

typedef UINT32                          LS_STATUS_CODE;
typedef UINT32                          LS_HANDLE;
typedef char                            LS_STR;
typedef unsigned char   LS_UCHAR;
typedef UINT32                          LS_ULONG;
typedef INT32                           LS_LONG;
typedef void                            LS_VOID;

typedef struct tagLS_MSG_DIGEST
	{
	LS_UCHAR                MessageDigest[16];
	} LS_MSG_DIGEST;

typedef struct tagLS_CHALLDATA
	{
	LS_ULONG                        SecretIndex;
	LS_ULONG                        Random;
	LS_MSG_DIGEST   MsgDigest;
	} LS_CHALLDATA;

typedef struct tagLS_CHALLENGE
	{
	LS_ULONG                        Protocol;
	LS_ULONG                        Size;
	LS_CHALLDATA    ChallengeData;
	} LS_CHALLENGE;

#define LS_DEFAULT_UNITS 0xFFFFFFFF
#define LS_ANY ""
#define LS_ALL "ALLSERVERS"
#define LS_USE_LAST 0x0000FFFF
#define LS_BASIC_PROTOCOL 0x00000001
#define LS_OUT_OF_BAND_PROTOCOL 0xFFFFFFFF
#define LS_NULL NULL
#define NETWARE_LS "NetWare LS"
#define LS_FIRST 0
#define LS_LAST 0xFFFFFFFF

#if defined(__cplusplus)
extern "C"
	{
#endif

extern LS_STATUS_CODE N_LSAPI_FUNCDEF LSRequest(
	LS_STR FAR *licenseSystem, LS_STR FAR *publisherName,
	LS_STR FAR *productName, LS_STR FAR *version, LS_ULONG totUnitsReserved,
	LS_STR FAR *logComment, LS_CHALLENGE FAR *challenge,
	LS_ULONG FAR *totUnitsGranted, LS_HANDLE FAR *licenseHandle);

extern LS_STATUS_CODE N_LSAPI_FUNCDEF LSRelease(
	LS_HANDLE licenseHandle, LS_ULONG totUnitsConsumed,
	LS_STR FAR *logComment);

extern void N_LSAPI_FUNCDEF LSFreeHandle(
	LS_HANDLE licenseHandle);

extern LS_STATUS_CODE N_LSAPI_FUNCDEF LSUpdate(
	LS_HANDLE licenseHandle, LS_ULONG totUnitsConsumed,
	LS_ULONG totUnitsReserved, LS_STR FAR *logComment,
	LS_CHALLENGE FAR *challenge, LS_ULONG FAR *totUnitsGranted);

extern LS_STATUS_CODE N_LSAPI_FUNCDEF LSGetMessage(
	LS_HANDLE licenseHandle, LS_STATUS_CODE value, LS_STR FAR *buffer,
	LS_ULONG bufferSize);

extern LS_STATUS_CODE N_LSAPI_FUNCDEF LSQuery(
	LS_HANDLE licenseHandle, LS_ULONG information, LS_VOID FAR *infoBuffer,
	LS_ULONG bufferSize, LS_ULONG FAR *actualBufferSize);

extern LS_STATUS_CODE N_LSAPI_FUNCDEF LSEnumProviders(
	LS_ULONG index, LS_STR FAR *buffer);

#if defined(__cplusplus)
};
#endif

#endif // NOVELL_LSAPI_INCLUDED
