#ifndef __npl_fsio_h__
#define __npl_fsio_h__
/*============================================================================
=  Novell Portability Layer Implementation
=
=  Unpublished Copyright (C) 1997 by Novell, Inc. All rights reserved.
=
=  No part of this file may be duplicated, revised, translated, localized or
=  modified in any manner or compiled, linked or uploaded or downloaded to or
=  from any computer system without the prior written consent of Novell, Inc.
=
=  npl/fsio.h
==============================================================================
*/
#include <npl/types.h>

/* File and Directory I/O */
int				NXCancelAsyncRW(int async_id);
int				NXPollAsyncRW(int async_id);
int				NXWaitAsyncRW(int async_id);
int				NXChdir(unicode *pathname);
int				NXClose(NXFHandle_t file_handle);
int				NXClosedir(NXDirHandle_t *dir_handle);
NXFHandle_t		NXCreat(unicode *filename, NXMode_t mode, int *ret_error);
int				NXGetCWD(const int bufsize, unicode *ret_path);
unicode			NXGetPathSep(void);
int				NXFLockUnlock(NXFHandle_t file_handle, int function,
						NXSize_t length);
NXSize_t			NXLSeek(NXFHandle_t file_handle, NXSize_t offset, int origin,
						int *ret_error);
int				NXMkdir(unicode *pathname, NXcmode_t mode);
NXFHandle_t		NXOpen(unicode *filename, NXMode_t mode, int *ret_error);
NXDirHandle_t	*NXOpendir(unicode *dirname, int *ret_error);
NXSize_t			NXPRead(NXFHandle_t file_handle, void *address, NXSize_t len,
						NXSize_t off, int *ret_error);
NXSize_t			NXPWrite(NXFHandle_t file_handle, void *address, NXSize_t len,
						NXSize_t off, int *ret_error);
NXSize_t			NXRead(NXFHandle_t file_handle, void *address, NXSize_t len,
						int *ret_error);
int				NXReadAsync(NXFHandle_t file_handle, void *address, NXSize_t len,
						void (*func) (void *, int), void *arg, int *ret_asyncid);
int				NXReaddir(NXDirHandle_t *dir_handle, NXDir_t *dir);
int				NXRewinddir(NXDirHandle_t *dir_handle);
void				NXSetPathSep(unicode path_sep);
int				NXStat(unicode *pathname, NXStatBuf_t *statbuf);
int				NXFStat(NXFHandle_t file_handle, NXStatBuf_t *statbuf);
NXBoolean_t		NXIsFileTransactional(NXFHandle_t file_handle);
int				NXSetFileTransactional(NXFHandle_t file_handle);
int				NXClearFileTransactional(NXFHandle_t file_handle);
int				NXCommitFileTransactions(NXFHandle_t file_handle);
int				NXUnlink(const unicode *pathname);
NXSize_t			NXWrite(NXFHandle_t file_handle, void *address,
						NXSize_t len, int *ret_error);
int				NXWriteAsync(NXFHandle_t file_handle, void *address,
						NXSize_t len, void (*func)(void *, int), void *arg,
						int *ret_asyncid);
#endif
