#ifndef __npl_types_h__
#define __npl_types_h__
/*============================================================================
=  Novell Portability Layer Implementation
=
=  Unpublished Copyright (C) 1997 by Novell, Inc. All rights reserved.
=
=  No part of this file may be duplicated, revised, translated, localized or
=  modified in any manner or compiled, linked or uploaded or downloaded to or
=  from any computer system without the prior written consent of Novell, Inc.
=
=  npl/types.h
==============================================================================
*/


typedef unsigned short		unicode;
typedef unsigned long		NXLong_t;
typedef unsigned long		NXSize_t;
typedef unsigned long		NXMode_t;
typedef void					*NXDir_t;
typedef unsigned long		NXcmode_t;
typedef int						NXWorkId_t;
typedef int						NXBoolean_t;
typedef int						NXFHandle_t;
typedef void					*NXContext_t;
typedef int						NXThreadId_t;
typedef int						NXDirHandle_t;
typedef int						NXHierarchy_t;
typedef int						NXInterruptId_t;
typedef unsigned __int64	NXInterruptSet_t;

typedef struct
{
	int	x;
} NXToId_t;

typedef struct
{
	unsigned long	seconds;
	unsigned long	micrseconds;
} NXTimeVal_t;

typedef struct
{
	unsigned long	it_interval;
	unsigned long	it_current;
} NXTimerVal_t;

typedef struct
{
	void				*mutex;
	NXThreadId_t	owner;
	int				hierarchy;
	void				*reserved[5];
} NXMutex_t;

typedef struct
{
	void				*mutex;
	NXThreadId_t	owner;
	int				hierarchy;
	void				*reserved[5];
} NXRWMutex_t;

typedef struct
{
	void				*semaphore;
	void				*reserved[3];
} NXSema_t;

typedef struct
{
	void				*cond;
	void				*reserved[3];
} NXCond_t;

typedef struct
{
	int	x;
} NXLockInfo_t;

typedef struct
{
	int	st_objectid;
	int	st_nlink;
	int	st_size;
	int	st_atime;
	int	st_mtime;
	int	st_ctime;
	int	st_attr;
	int	st_xattr;
} NXStatBuf_t;

#endif
