/****************************************************************************
*
* 1995 (C) Unpublished Copyright Novell, Inc. All Rights Reserved.
*
* No part of this file may be duplicated, revised, translated,
* localized or modified in any manner or compiled, linked or 
* uploaded or downloaded to or from any computer system without
* the prior written consent of Novell, Inc.
*
*****************************************************************************/

/*
 * $Source: I:SRC\LSP\OBJECTS/RCS/tags.h $
 * $Log:	tags.h $
 * Revision 1.12  96/08/12  13:53:40  clifwlkr
 * Added new tag define for the maximum units installed flag
 * 
 * Revision 1.11  96/01/18  10:20:41  clifwlkr
 * Added tags for the file server assign stuff
 * 
 * Revision 1.10  95/08/01  13:15:53  clifwlkr
 * Added NLS_LIC_NODAL_REUSE and NLS_LIC_USER_REUSE nls attributes
 * 
 * Revision 1.9  95/03/08  11:03:00  clifwlkr
 * Added internationalization and copyright information
 * 
 * Revision 1.8  95/03/07  12:49:20  clifwlkr
 * Added a tag for the activation key
 * 
 * Revision 1.7  95/02/09  15:50:29  clifwlkr
 * Added the tag size parameter to help avoid over-runs
 * 
 * Revision 1.6  94/11/23  14:04:25  clifwlkr
 * Added binary tag capability
 * 
 * Revision 1.5  94/10/27  13:17:17  clifwlkr
 * Added NLS specific tags
 * 
 * Revision 1.4  94/10/05  09:43:24  clifwlkr
 * Cleaned up memory creep, added additional policy tags, and generally debuged
 * 
 * Revision 1.3  94/09/08  17:05:47  clifwlkr
 * Added tags for the owner information and the assignments
 * 
 * Revision 1.2  94/08/31  20:07:18  clifwlkr
 * Added addtional new line at EOF
 * 
 * Revision 1.1  94/08/03  15:13:51  clifwlkr
 * Initial revision
 * 
 * $EndLog$
 */

#if !defined(NOVELL_NLS_TAGS_H)

#define NOVELL_NLS_TAGS_H

// I added "const" to all the #define statements -- cwalker

#include <lsapi.h>

#define LS_LIC_TAG_NODE_LEN		8

typedef struct LSLICTAGTTag
	{
	unsigned char	nodeID[LS_LIC_TAG_NODE_LEN];
	LS_ULONG       protocol;
	LS_ULONG			timeInSecs;
	LS_ULONG			milliSecs;
	} LS_LIC_TAG_T;

#define	LS_TCPIP_PROTOCOL		1
#define	LS_TAG_SIZE				(LS_LIC_TAG_NODE_LEN + (3 * sizeof(LS_ULONG)))

#if !defined(NOVELL_NLS_CERT_H) || defined(NLS_INCL_TAGS)
#define LSAPI_CERTIFICATE_TAG           1
const
LS_LIC_TAG_T	LSCertificateTag =
	{{137, 65, 21, 73}, LS_TCPIP_PROTOCOL, 785521927, 100};

#define LSAPI_PUBLISHER_TAG             2
const
LS_LIC_TAG_T	LSPublisherTag =
	{{137, 65, 21, 73}, LS_TCPIP_PROTOCOL, 785521928, 225};

#define LSAPI_PRODUCT_TAG               3
const
LS_LIC_TAG_T	LSProductTag =
	{{137, 65, 21, 73}, LS_TCPIP_PROTOCOL, 785521929, 59};

#define LSAPI_VERSION_TAG               4
const
LS_LIC_TAG_T	LSVersionTag =
	{{137, 65, 21, 73}, LS_TCPIP_PROTOCOL, 785521929, 983};

#define LSAPI_SECRETS_TAG               5
const
LS_LIC_TAG_T	LSSecretsTag =
	{{137, 65, 21, 73}, LS_TCPIP_PROTOCOL, 785521931, 148};

#define LSAPI_INSTALLED_UNITS_TAG       6
const
LS_LIC_TAG_T	LSInstalledUnitsTag =
	{{137, 65, 21, 73}, LS_TCPIP_PROTOCOL, 785521932, 316};

#define LSAPI_START_DATE_TAG            7
const
LS_LIC_TAG_T	LSStartDateTag =
	{{137, 65, 21, 73}, LS_TCPIP_PROTOCOL, 785521933, 731};

#define LSAPI_EXP_DATE_TAG              8
const
LS_LIC_TAG_T	LSExpirationDateTag =
	{{137, 65, 21, 73}, LS_TCPIP_PROTOCOL, 785521934, 25};

#define LSAPI_LICENSE_ID_TAG            9
const
LS_LIC_TAG_T	LSLicenseIDTag =
	{{137, 65, 21, 73}, LS_TCPIP_PROTOCOL, 785521934, 894};

#define LSAPI_DEFAULT_METERED_TAG       10
const
LS_LIC_TAG_T	LSDefaultMeteredTag =
	{{137, 65, 21, 73}, LS_TCPIP_PROTOCOL, 785521936, 74};

#define LSAPI_ASSIGN_REQUIRED_TAG       11
const
LS_LIC_TAG_T	LSAssignmentRequiredTag =
	{{137, 65, 21, 73}, LS_TCPIP_PROTOCOL, 785521937, 327};

#define LSAPI_SYSTEM_AREA_TAG           12
const
LS_LIC_TAG_T	LSSystemAreaTag =
	{{137, 65, 21, 73}, LS_TCPIP_PROTOCOL, 785521945, 472};

#define LSAPI_DEFAULT_UPDATE_TAG				13
const
LS_LIC_TAG_T	LSDefaultUpdateTag =
	{{137, 65, 21, 73}, LS_TCPIP_PROTOCOL, 785521946, 372};

#define LSAPI_DEF_UNITS_TO_CONSUME_TAG	14
const
LS_LIC_TAG_T	LSDefaultUnitsTag =
	{{137, 65, 21, 73}, LS_TCPIP_PROTOCOL, 785521948, 193};

#define NLS_USER_INFO                 	20
const
LS_LIC_TAG_T	NLSUserInfoTag =
	{{137, 65, 21, 75}, LS_TCPIP_PROTOCOL, 785521983, 491};

#define NLS_OWNER												25
const
LS_LIC_TAG_T	NLSOwnerTag =
	{{137, 65, 21, 75}, LS_TCPIP_PROTOCOL, 785521987, 852};

#define NLS_ASSIGNMENT									30
const
LS_LIC_TAG_T	NLSAssignmentTag =
	{{137, 65, 21, 75}, LS_TCPIP_PROTOCOL, 785521993, 467};

#define NLS_FS_ASSIGNMENT								31
const
LS_LIC_TAG_T	NLSFSAssignmentTag =
	{{137, 65, 21, 75}, LS_TCPIP_PROTOCOL, 785522032, 310};

#define NLS_ACTIVATION_KEY							35
const
LS_LIC_TAG_T	NLSActivationKeyTag =
	{{137, 65, 21, 75}, LS_TCPIP_PROTOCOL, 785521993, 567};

#define NLS_SYSTEM_AREA									40
const
LS_LIC_TAG_T	NLSSystemAreaTag =
	{{137, 65, 21, 75}, LS_TCPIP_PROTOCOL, 785522031, 320};

#define NLS_LIC_CONSUMABLE							41
#define NLS_LIC_SHAREABLE								42
#define NLS_LIC_PP_SECURED							43
#define NLS_LIC_HW_SECURED							44
#define NLS_LIC_MAX_UNITS_TO_CONSUME		45
#define NLS_LIC_MIN_UNITS_TO_CONSUME		46
#define NLS_LIC_NODAL_REUSE							47
#define NLS_LIC_USER_REUSE							48
#define NLS_FS_ASSIGN_REQ								49

// The error policy tags
#define NLS_ERR_INSUF_UNITS							50
#define NLS_ERR_LIC_TERM								51
#define NLS_ERR_LIC_UNAVAIL							52
#define NLS_ERR_RES_UNAVAIL							53
#define NLS_ERR_LIC_EXPIRED							54

// New Tags
#define NLS_LIC_MAX_UNITS_INSTALLED			60
#define NLS_LIC_CHECK_SUM								61
#define NLS_STOP_POLICY									62
#define NLS_POLICY_MODEL								63
#define NLS_DUP_INST_ALLOWED						64
#define NLS_TIME_BOMB										65
#define NLS_OEM_ID											66

#else
extern LSLICTAGTTag LSCertificateTag;
extern LSLICTAGTTag LSPublisherTag;
extern LSLICTAGTTag LSProductTag;
extern LSLICTAGTTag LSVersionTag;
extern LSLICTAGTTag LSSystemAreaTag;
extern LSLICTAGTTag NLSSystemAreaTag;

#endif
#endif

