/*
//ͻ
// (c) 1995-1998 Novell, Inc.  All rights reserved.                         
//                                                                          
// THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND        
// TREATIES.                                                                
//                                                                          
// NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,          
// DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         
// EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED    
// WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        
//                                                                          
// ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT 
// THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.                         
//͹
// Source module name: NWDP_PRT.H                                           
//͹
// Library VeRsIoN=1.1.0                                                    
//ͼ
*/
/* Inclusion Control */
#if !defined( NWDP_PRT_H )
   #define NWDP_PRT_H

/* Standard Library Header Includes */
   #if !defined(NWDP_LIB_H)
      #include <nwdp_lib.h>
   #endif
   #if !defined(NWDP_NSR_H)
      #include <nwdp_nsr.h>
   #endif
   #if !defined(NWDP_OID_H)
      #include <nwdp_oid.h>
   #endif
   #if !defined(NWDP_PSM_H)
      #include <nwdp_psm.h>
   #endif
   #if !defined(NWDP_RES_H)
      #include <nwdp_res.h>
   #endif
   

/* Header Includes */

/* Manifest Constant Definitions */
   /*
   // length definition sizes
   */
   #if !defined(NWDP_PRT_MAX_NAME_CHARS)
      #define NWDP_PRT_MAX_NAME_CHARS                 63
      #define NWDP_PRT_MAX_NAME_BYTES \
            ((NWDP_PRT_MAX_NAME_CHARS+1)*2)

      #define NWDP_PRT_MAX_CONFIG_NAME_CHARS          31
      #define NWDP_PRT_MAX_CONFIG_NAME_BYTES \
            ((NWDP_PRT_MAX_CONFIG_NAME_CHARS+1)*2)

      #define NWDP_PRT_MAX_LABEL_CHARS                31
      #define NWDP_PRT_MAX_LABEL_BYTES \
            ((NWDP_PRT_MAX_LABEL_CHARS+1)*2)

      #define NWDP_PRT_MAX_PORT_CHARS                 8
      #define NWDP_PRT_MAX_PORT_BYTES \
            ((NWDP_PRT_MAX_PORT_CHARS+1)*2)

      #define NWDP_PRT_MAX_DRIVER_CHARS               31          
      #define NWDP_PRT_MAX_DRIVER_BYTES \
            ((NWDP_PRT_MAX_DRIVER_CHARS+1)*2)

      #define NWDP_PRT_MAX_DESCRIPTION_CHARS          127
      #define NWDP_PRT_MAX_DESCRIPTION_BYTES \
            ((NWDP_PRT_MAX_DESCRIPTION_CHARS+1)*2)

      #define NWDP_PRT_MAX_LOCATION_CHARS             127
      #define NWDP_PRT_MAX_LOCATION_BYTES \
            ((NWDP_PRT_MAX_LOCATION_CHARS+1)*2)

      /*
      // Ports and printer names in the registry
      // can have the UNC form of \\<Tree>\<DN>.
      */
      #define NWDP_REG_MAX_NAME_CHARS  \
                           (NWDP_NSRV_MAX_TREE_CHARS+NWDP_NSRV_MAX_DN_CHARS+3)
      #define NWDP_REG_MAX_NAME_BYTES \
            ((NWDP_REG_MAX_NAME_CHARS+1)*2)

   #endif

   #if defined(N_PLAT_MSW)
      #if !defined(NWDP_PRT_INSTALLED_LIST_CHG_MSG)
         #define NWDP_PRT_INSTALLED_LIST_CHG_MSG "NDPS Installed Printer List Changed"
      #endif
   #endif

   /*
   // flag bits for NWDPPrtAddInstalledPrinter
   */
   #define NWDP_PRT_FLG_NO_REF               0x00000001L
   #define NWDP_PRT_FLG_CONVERT_REF          0x00000002L
   #define NWDP_PRT_FLG_PRINT_PROVIDER       0x00000004L
   #define NWDP_PRT_FLG_RPM                  0x00000008L

   /*
   // flag bits for NWDPPrtDownloadAndAddDriver
   */
   #define NWDP_PRT_DONT_ADD_DRV_AND_MON     0x00000001L
   #define NWDP_PRT_OVERWRITE_OLD_FILES      0x00000002L
   #define NWDP_PRT_USE_ANY_RESOURCE_MGR     0x00000004L
   #define NWDP_PRT_ALWAYS_RETURN_RESREF     0x00000008L
   #define NWDP_PRT_ALWAYS_RETURN_DRIVERID   0x00000010L
   #define NWDP_PRT_NO_USER_PROMPTS          0x00000020L


   #define NWDP_PRT_REF_TYPE_ANY \
      (NWDP_PRT_REF_TYPE_INSTALLED | \
       NWDP_PRT_REF_TYPE_CTRLED_ACCESS | \
       NWDP_PRT_REF_TYPE_PUBLIC_ACCESS)

/* Macro Definitions */

/* Type Definitions */
#define N_PACK_1
#include <npackon.h>

   #if !defined(_NWDP_PRT_REF_TYPE)
      #define _NWDP_PRT_REF_TYPE

      #define NWDP_PRT_REF_TYPE_NAMED       NWDP_PRT_REF_TYPE_CTRLED_ACCESS
      #define NWDP_PRT_REF_TYPE_CONVENIENCE NWDP_PRT_REF_TYPE_PUBLIC_ACCESS

      typedef enum
      {
         NWDP_PRT_REF_TYPE_INSTALLED     = 1,
         NWDP_PRT_REF_TYPE_CTRLED_ACCESS = 2,
         NWDP_PRT_REF_TYPE_PUBLIC_ACCESS = 4
      } NWDPPrtRefTypeEnum, N_FAR *pNWDPPrtRefTypeEnum;
   #endif

   typedef enum
   {
      NWDP_PRT_CFG_FILE_TYPE_PDS,
      NWDP_PRT_CFG_FILE_TYPE_PH     
   } NWDPPrtConfigFileTypeEnum, N_FAR *pNWDPPrtConfigFileTypeEnum;

   /*
   // local printers callback item structure
   */
   typedef struct
   {
      nbool                defaultPrinter;
      nchar16              name16[  NWDP_PRT_MAX_NAME_CHARS   + 1];
      nchar16              driver16[NWDP_PRT_MAX_DRIVER_CHARS + 1];
      nchar16              label16[ NWDP_PRT_MAX_LABEL_CHARS  + 1];
      nchar16              port16[  NWDP_PRT_MAX_PORT_CHARS   + 1];
   } NWDPPrtInstalledListItem, N_FAR *pNWDPPrtInstalledListItem;

   /*
   // label16Ptr in NWDPPrtInstalledListItem2 is not used for win32.
   */
   typedef struct
   {
      nbool    defaultPrinter;
      pnchar16 name16Ptr;           /* Max of NWDP_REG_MAX_NAME_CHARS+1  */ 
      pnchar16 driverKeyName16Ptr;  /* Max of NWDP_PRT_MAX_NAME_CHARS+1  */
      pnchar16 label16Ptr;          /* Max of NWDP_PRT_MAX_LABEL_CHARS+1 */
      pnchar16 port16Ptr;           /* Max of NWDP_REG_MAX_NAME_CHARS+1  */
      pnchar16 printerUNC16Ptr;     /* Max of NWDP_REG_MAX_NAME_CHARS+1  */
      nuint32  timeStamp;           /* For RPM */  
   } NWDPPrtInstalledListItem2, N_FAR *pNWDPPrtInstalledListItem2;


   /*
   // global printers callback item structure
   */
   typedef struct
   {
      nchar16 printerName16[ NWDP_PRT_MAX_NAME_CHARS + 1];
      nchar16 description16[ NWDP_PRT_MAX_DESCRIPTION_CHARS + 1];
      nchar16 location16   [ NWDP_PRT_MAX_LOCATION_CHARS + 1];
      NWDPPrtRefTypeEnum printerType;
      union {
         struct {
            NWDPNetAddress address;
         } convenience;
         NWDPNSrvFQNBuffer   named;
      } u;

   } NWDPPrtGlobalListItem, N_FAR *pNWDPPrtGlobalListItem;


   /*
   // Printer Job-list callback item
   */
   typedef struct 
   {
      nuint32                 jobId;
      nuint32                 jobPosition;
      pnstr16                 jobName16Ptr;
      pnstr16                 jobOwner16Ptr;
      nuint32                 jobSize;
      nuint                   numDocs;
      nuint                   jobPriority;
      nuint32                 submitTime;
      pNWDPOid                jobStateOidPtr;
   } NWDPPrtJobListItem, N_FAR *pNWDPPrtJobListItem;


   typedef enum
   {
      NWDP_PRT_SCHEDULED_JOBS,
      NWDP_PRT_RETAINED_JOBS
   } NWDPPrtJobTypeEnum, N_FAR *pNWDPPrtJobTypeEnum;

   typedef enum {
      NWDP_PRT_DRV_OVERWRITE_ALL       = 1,
      NWDP_PRT_DRV_OVERWRITE_IF_NEWER  = 2,
      NWDP_PRT_DRV_OVERWRITE_DONT      = 3,
      NWDP_PRT_DRV_INTERVENE_EACH_CPY  = 4,
      NWDP_PRT_DRV_INTERVENE_OVRWRITE  = 5,
      NWDP_PRT_DRV_INTERVENE_OVRW_NEW  = 6
   } NWDPPrtDrvDownloadOptionEnum, N_FAR *pNWDPPrtDrvDownloadOptionEnum;

   /*
   // These actions affect only the disposition of the current file
   // for which there is intervention.
   */
   typedef enum {
      NWDP_PRT_DRV_RETAIN_ORIGINAL     = 0,
      NWDP_PRT_DRV_COPY_FILE           = 1
   } NWDPPrtDrvDownloadActionEnum, N_FAR *pNWDPPrtDrvDownloadActionEnum;


#include <npackoff.h>

/* Callback Definitions */

 N_TYPEDEF_CALLBACK(nint,
NWDPPrtDownloadInterventionCB)(  
   NWDPAccessorRef               accessorRef,                /* :I  */
   nparam                        callerDefinedParam,         /* :I  */
   nint                          totalCallsToBeMade,         /* :I  */
   nint                          currentCallCount,           /* :I  */
   pnstr                         filenameToBeCopiedPtr,      /* :I  */
   nint32                        toBeCopiedFileDate,         /* :I  */
   nint32                        originalFileDate,           /* :I  */
   pNWDPPrtDrvDownloadOptionEnum currentDownloadOptionPtr,   /* :IO */
   pNWDPPrtDrvDownloadActionEnum actionToBeTakenPtr          /* : O */
   );

 N_TYPEDEF_CALLBACK(nint,
NWDPPrtGlobalListCallback)(
   NWDPAccessorRef         accessorRef,
   nparam                  callerDefinedParam,
   nint                    totalCallsToBeMade,
   nint                    currentCallCount,
   pNWDPPrtGlobalListItem  itemReceivedPtr
   );

 N_TYPEDEF_CALLBACK(nint,
NWDPPrtInstalledListCallback)(
   NWDPAccessorRef            accessorRef,
   nparam                     callerDefinedParam,
   nint                       totalCallsToBeMade,
   nint                       currentCallCount,
   pNWDPPrtInstalledListItem  itemReceivedPtr
   );

 N_TYPEDEF_CALLBACK(nint,
NWDPPrtInstalledListCallback2)(
   NWDPAccessorRef            accessorRef,
   nparam                     callerDefinedParam,
   nint                       totalCallsToBeMade,
   nint                       currentCallCount,
   pNWDPPrtInstalledListItem2 itemReceivedPtr
   );


   /*
   // Job Configuration callback item is an ASCII string
   */
 N_TYPEDEF_CALLBACK(nint,
NWDPPrtJobConfigListCallback)(
   NWDPAccessorRef   accessorRef,
   nparam            callerDefinedParam,
   nint              totalCallsToBeMade,
   nint              currentCallCount,
   pnstr16           itemReceived16Ptr
   );

 N_TYPEDEF_CALLBACK(nint,
NWDPPrtJobListCallback)(
   NWDPAccessorRef      accessorRef,
   nparam               callerDefinedParam,
   nint                 totalCallsToBeMade,
   nint                 currentCallCount,
   pNWDPPrtJobListItem  itemReceivedPtr
   );

/* Global Variable Declarations */

/* Function Prototype Declarations */

 N_EXTERN_LIBRARY(nint)
NWDPPrtAddInstalledPrinter(
   NWDPAccessorRef   accessorRef,
   NWDPPrtRef        printerRef,
   pnstr16           jobConfigName16Ptr,
   pnstr16           label16Ptr,
   pNWDPPrtRef       localPrinterRefPtr,
   nuint32           flags
   );

 /* New for 1.1 */
 N_EXTERN_LIBRARY(nint)
NWDPPrtAddInstalledPrinter2(
   NWDPAccessorRef   accessorRef,
   NWDPPrtRef        printerRef,
   pnstr             driverNamePtr,
   pnstr16           jobConfigName16Ptr,
   pnstr16           name16Ptr,
   pNWDPPrtRef       localPrinterRefPtr,
   nuint32           flags
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtAddInstalledPrtWConfig(
   NWDPAccessorRef      accessorRef,
   NWDPPrtRef           printerRef,
   NWDPAttrSetRef       jobConfigRef,
   NWDPAttrSetRef       docConfigRef,
   pnstr16              label16Ptr,
   pNWDPPrtRef          localPrinterRefPtr,
   nuint32              flags
   );

 /* New for 1.1 */
 N_EXTERN_LIBRARY(nint)
NWDPPrtAddInstalledPrinterWCfg(
   NWDPAccessorRef      accessorRef,
   NWDPPrtRef           printerRef,
   pnstr                driverNamePtr,
   NWDPAttrSetRef       jobConfigRef,
   NWDPAttrSetRef       docConfigRef,
   pnstr16              name16Ptr,
   pNWDPPrtRef          localPrinterRefPtr,
   nuint32              flags
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtAddJobConfig(
   NWDPAccessorRef      accessorRef,
   NWDPPrtRef           printerRef,
   pnstr16              jobConfigName16Ptr,
   NWDPAttrSetRef       jobConfigRef,
   NWDPAttrSetRef       docConfigRef
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtAddPrinterObjToPA(
   NWDPAccessorRef accessorRef,
   NWDPPrtRef printerRef,
   pNWDPNSrvFQN printerFqnPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtCallVendorSetup(
   NWDPAccessorRef accessorRef,
   NWDPPrtRef      printerRef,
   pnstr           printerNamePtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtChangeMedia(
   NWDPAccessorRef            accessorRef,
   NWDPPrtRef                 printerRef,
   nuint32                    trayNumber, 
   pNWDPNameOrOid             mediumValuePtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtControl(
   NWDPAccessorRef            accessorRef,
   NWDPPrtRef                 printerRef,
   pNWDPOid                   actionOidPtr 
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtCreateMODObject(
   NWDPAccessorRef            accessorRef,
   NWDPPrtRef                 printerRef,
   pNWDPOid                   objectClassPtr,
   pNWDPObjectIdentification  objectIdentPtr,
   nbool                      force,
   pNWDPObjectIdentification  referenceObjectPtr,
   NWDPAttrSetRef             objectAttrSetRef,
   pNWDPAttrSetRef            resultAttrSetRefPtr,
   pNWDPASAVPRef              resultAvpRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtCreateRefBasedOnAddr(
   NWDPAccessorRef   accessorRef,
   pNWDPNetAddress   netAddrPtr,
   pnstr16           paName16Ptr,      /* NWDP_PSM_MAX_PA_NAME_CHARS */
   pNWDPPrtRef       printerRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtCreateRefBasedOnFQN(
   NWDPAccessorRef      accessorRef,
   pNWDPNSrvFQN         printerFqnPtr,
   pNWDPPrtRef          printerRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtCreateRefBasedOnLabel(
   NWDPAccessorRef   accessorRef,
   pnstr16           label16Ptr,
   pNWDPPrtRef       printerRefPtr
   );

 /* New for 1.1 */
 N_EXTERN_LIBRARY(nint)
NWDPPrtCreateRefBasedOnPAP(
   NWDPAccessorRef      accessorRef,
   pnstr16              publicAccessPrinterName16Ptr,
   pNWDPPrtRef          printerRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtCreateRefBasedOnPort(
   NWDPAccessorRef   accessorRef,
   pnstr16           port16Ptr,
   pNWDPPrtRef       printerRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtCreateRefBasedOnPSM(
   NWDPAccessorRef   accessorRef,
   NWDPPsmRef        psmRef,
   pnstr16           paName16Ptr,      /* NWDP_PSM_MAX_PA_NAME_CHARS */
   pNWDPPrtRef       printerRefPtr
   );

 /* New for 1.1 */
 N_EXTERN_LIBRARY(nint)
NWDPPrtCreateRefBasedOnRegName(
   NWDPAccessorRef accessorRef,
   pnstr16 name16Ptr,
	pNWDPPrtRef printerRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtDeleteAllJobs(
   NWDPAccessorRef accessorRef,
   NWDPPrtRef printerRef,
   pNWDPNameOrOid  reservedPtr   /* internal use only - pass NULL */
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtDeleteMODObject(
   NWDPAccessorRef            accessorRef,
   NWDPPrtRef                 printerRef,
   pNWDPOid                   objectClassPtr,
   pNWDPObjectIdentification  objectIdentPtr
   );

 /* New for 1.1 */
 N_EXTERN_LIBRARY(nint)
NWDPPrtDownloadAndAddDriver(
   NWDPAccessorRef               accessorRef,
   nptr                          optionalWindowHandle,
   NWDPPrtRef                    printerRef,
   pNWDPResRef                   resourceRefPtr,
   pNWDPResListDrvFiles2  N_FAR *driverIdPtrPtr,
   pnstr                         sourcePathOptionPtr,
   pnptr                         driverInfoStructPtrPtr,
   pnptr                         monitorInfoStructPtrPtr,
   nuint32                       flags
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtDriverDownload(
   NWDPAccessorRef               accessorRef,
   NWDPPrtRef                    printerRef,
   NWDPResRef                    optionalResourceRef,
   pNWDPResListDrvFiles          optionalDriverIdPtr,
   NWDPPrtDrvDownloadOptionEnum  downloadOption,
   pnstr                         sourcePathOptionPtr,
   NWDPPrtDownloadInterventionCB callback,
   nparam                        callerDefinedParam
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtGetAttributeSet(
   NWDPAccessorRef   accessorRef,
   NWDPPrtRef        printerRef,
   NWDPOidSetRef     requestedOidSetRef,
   pNWDPAttrSetRef   resultAttrSetRefPtr,
   pNWDPASAVPRef     avpRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtGetDefaultPrinter(
   NWDPAccessorRef   accessorRef,
   pNWDPPrtRef       printerRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtGetDriverKeyName(
   NWDPAccessorRef   accessorRef,
   NWDPPrtRef        printerRef,
   nuint             sizeOfBuffer,
   pnstr16           driverKeyNameBuffer16Ptr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtGetDriverName(
   NWDPAccessorRef   accessorRef,
   NWDPPrtRef        printerRef,
   nuint             sizeOfBuffer,
   pnstr16           driverNameBuffer16Ptr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtGetFQN(
   NWDPAccessorRef      accessorRef,
   NWDPPrtRef           printerRef,
   nuint                sizeOfBuffer,
   pNWDPNSrvFQNBuffer   fqnBufferPtr,
   pnuint               sizeOfResultPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtGetJobConfig(
   NWDPAccessorRef      accessorRef,
   NWDPPrtRef           printerRef,
   nuint                sizeOfJobConfigNameBuffer,
   pnstr16              jobConfigName16Ptr,
   pnuint               sizeOfResultNamePtr,
   pNWDPAttrSetRef      jobConfigRefPtr,
   pNWDPASAVPRef        jobAvpRefPtr,
   pNWDPAttrSetRef      docConfigRefPtr,
   pNWDPASAVPRef        docAvpRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtGetLabel(
   NWDPAccessorRef   accessorRef,
   NWDPPrtRef        printerRef,
   nuint             sizeOfBuffer,
   pnstr16           label16Ptr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtGetMODObjectAttrSet(
   NWDPAccessorRef            accessorRef,
   NWDPPrtRef                 printerRef,
   pNWDPOid                   objectClassPtr,
   pNWDPObjectIdentification  objectIdentPtr,          
   NWDPOidSetRef              requestedOidSetRef,
   pNWDPAttrSetRef            resultAttrSetRefPtr,
   pNWDPASAVPRef              resultAvpRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtGetPort(
   NWDPAccessorRef   accessorRef,
   NWDPPrtRef        printerRef,
   nuint             sizeOfBuffer,
   pnstr16           portBuffer16Ptr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtGetPrinterInfo(
   NWDPAccessorRef   accessorRef,
   NWDPPrtRef        printerRef,
   pNWDPPrtGlobalListItem infoItemPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtGetRefType(
   NWDPAccessorRef   accessorRef,
   NWDPPrtRef        printerRef,
   pnuint32          refTypeFlagsPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtGetRegName(
   NWDPAccessorRef   accessorRef,
   NWDPPrtRef        printerRef,
   nuint             sizeOfBuffer,
   pnstr16           name16Ptr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtGetStatus(
   NWDPAccessorRef   accessorRef,
   NWDPPrtRef        printerRef,
   pNWDPAttrSetRef   resultAttrSetRefPtr,
   pNWDPASAVPRef     avpRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtJobCopy(
   NWDPAccessorRef   accessorRef,
   NWDPPrtRef        destPrinterRef,
   NWDPPrtRef        srcPrinterRef,
   nuint32           jobId,
   pNWDPJobRef       destJobRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtJobMove(
   NWDPAccessorRef   accessorRef,
   NWDPPrtRef        destPrinterRef,
   NWDPPrtRef        srcPrinterRef,
   nuint32           jobId,
   pNWDPJobRef       destJobRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtListGlobalPrinters(
   NWDPAccessorRef            accessorRef,
   NWDPFilterRef              filterRef,
   NWDPPrtRefTypeEnum         printerTypeFilter,
   NWDPPrtGlobalListCallback  listCallback,
   nparam                     callerDefinedParam
   );

/*
// Outdated - Use NWDPPrtListInstalledPrinters2 
*/ 
 N_EXTERN_LIBRARY(nint)
NWDPPrtListInstalledPrinters(
   NWDPAccessorRef               accessorRef,
   NWDPPrtInstalledListCallback  listCallback,
   nparam                        callerDefinedParam
   );

/* New for 1.1 */
 N_EXTERN_LIBRARY(nint)
NWDPPrtListInstalledPrinters2(
   NWDPAccessorRef               accessorRef,
   NWDPPrtInstalledListCallback2 listCallback,
   nparam                        callerDefinedParam
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtListJobConfigs(
   NWDPAccessorRef               accessorRef,
   NWDPPrtRef                    printerRef,
   NWDPPrtJobConfigListCallback  listCallback,
   nparam                        callerDefinedParam
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtListJobs(
   NWDPAccessorRef         accessorRef,
   NWDPPrtRef              printerRef,
   NWDPPrtJobTypeEnum      jobType,
   NWDPFilterRef           filterRef,
   NWDPPrtJobListCallback  listCallback,
   nparam                  callerDefinedParam
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtListMODObjects(
   NWDPAccessorRef             accessorRef,
   NWDPPrtRef                  printerRef,
   pNWDPOid                    objectClassPtr,
   pNWDPASSelector             selectorPtr,          
   NWDPOidSetRef               requestedOidSetRef,
   NWDPASMODObjectListCallback listCallback,
   nparam                      callerDefinedParam
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtModifyAttrs(
   NWDPAccessorRef   accessorRef,
   NWDPPrtRef        printerRef,
   NWDPAttrSetRef    modifyRef,
   NWDPModifyOperatorEnum prtOperator
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtModifyMODObjectAttrs(
   NWDPAccessorRef            accessorRef,
   NWDPPrtRef                 printerRef,
   pNWDPOid                   objectClassPtr,
   pNWDPObjectIdentification  objectIdentPtr,          
   NWDPAttrSetRef             modifyRef,
   NWDPModifyOperatorEnum     modifyOperator
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtReleaseRef(
   NWDPAccessorRef   accessorRef,
   pNWDPPrtRef       printerRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtRemoveInstalledPrinter(
   NWDPAccessorRef   accessorRef,
   pNWDPPrtRef       printerRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtRemoveJobConfig(
   NWDPAccessorRef   accessorRef,
   NWDPPrtRef        printerRef,
   pnstr16           jobConfigName16Ptr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtRemovePrinterObjFromPA(
   NWDPAccessorRef accessorRef,
   NWDPPrtRef printerRef,
   pNWDPNSrvFQN printerFqnPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtRenameJobConfig(
   NWDPAccessorRef   accessorRef,
   NWDPPrtRef        printerRef,
   pnstr16           oldJobConfigName16Ptr,
   pnstr16           newJobConfigName16Ptr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtResyncWithNameService(
   NWDPAccessorRef accessorRef,
   NWDPPrtRef printerRef
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtSetDefaultPrinter(
   NWDPAccessorRef   accessorRef,
   NWDPPrtRef        printerRef
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtSetDriver(
   NWDPAccessorRef accessorRef,
	NWDPPrtRef printerRef,
   pnstr driverNamePtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtSetLabel(
   NWDPAccessorRef   accessorRef,
   NWDPPrtRef        printerRef,
   pnstr16           label16Ptr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtShutdownPA(
   NWDPAccessorRef      accessorRef,
   NWDPPrtRef           printerRef,
   pNWDPNameOrOid       reservedPtr,   /* internal use only - pass NULL */
   NWDPShutdownType  shutdownType
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtStartupPA(
   NWDPAccessorRef accessorRef,
   NWDPPrtRef      printerRef,
   pNWDPNameOrOid  reservedPtr   /* internal use only - pass NULL */
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtSyncInstalledPrinters(
   NWDPAccessorRef accessorRef,
   nbool osRegistryTakesPrecedence
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtUseRef(
   NWDPAccessorRef   accessorRef,
   NWDPPrtRef        printerRef
   );

 N_EXTERN_LIBRARY(nint)
NWDPPrtValidateRef(
   NWDPAccessorRef accessorRef,
	NWDPPrtRef printerRef,
   NWDPPrtRefTypeEnum refType
   );

#else /* NWDP_PRT_H is defined. */

   #if defined(N_DEBUG)
      #error nwdp_prt.h has already been included.
   #endif /* N_DEBUG */

#endif /* NWDP_PRT_H */
