/*
//ͻ
// (c) 1995-1998 Novell, Inc.  All rights reserved.                         
//                                                                          
// THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND        
// TREATIES.                                                                
//                                                                          
// NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,          
// DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         
// EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED    
// WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        
//                                                                          
// ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT 
// THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.                         
//͹
// Source module name: NWDP_PSM.H                                           
//͹
// Library VeRsIoN=1.1.0                                                    
//ͼ
*/
/* Inclusion Control */
#if !defined( NWDP_PSM_H )
   #define NWDP_PSM_H

/* Standard Library Header Includes */

/* Header Includes */
   #if !defined(NWDP_ATR_H)
      #include <nwdp_atr.h>
   #endif
   #if !defined(NWDP_SOK_H)
      #include <nwdp_sok.h>
   #endif

/* Manifest Constant Definitions */
   #define NWDP_PSM_MAX_PA_NAME_CHARS     31
   #define NWDP_PSM_MAX_PA_NAME_BYTES     ((NWDP_PSM_MAX_PA_NAME_CHARS+1)*2)

/* Macro Definitions */

/* Type Definitions */
#define N_PACK_1
#include <npackon.h>

   /*
   // NWDPPsmShutdownType enum
   */
   typedef enum
   {
      NWDP_SHUTDOWN_DO_CURRENT_JOBS = 0,
      NWDP_SHUTDOWN_IMMEDIATE = 1,
      NWDP_SHUTDOWN_DO_PENDING_JOBS = 2
   } NWDPShutdownType, N_FAR *pNWDPShutdownType;

   /*
   // "Printer Agent" list callback item structure
   */
   typedef struct
   {
      pnstr16                 paName16Ptr;
      pnstr16                 phStartup16Ptr;
      pnstr16                 pdsStartup16Ptr;
      pNWDPOid                paStateOidPtr;
      nbool                   printerEnabled;         /* Input Paused */
   } NWDPPsmPAListItem, N_FAR *pNWDPPsmPAListItem;


#include <npackoff.h>

/* Callback Definitions */
 N_TYPEDEF_CALLBACK(nint,
NWDPPsmPAListCallback)(
   NWDPAccessorRef      accessorRef,
   nparam               callerDefinedParam,
   nint                 totalCallsToBeMade,
   nint                 currentCallCount,
   pNWDPPsmPAListItem   itemReceivedPtr
   );

/* Global Variable Declarations */

/* Function Prototype Declarations */

 N_EXTERN_LIBRARY(nint)
NWDPPsmAddPA(
   NWDPAccessorRef         accessorRef,
   NWDPPsmRef              psmRef,
   pnstr16                 paName16Ptr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPsmAddPAAndAssignPrinterObj(
   NWDPAccessorRef         accessorRef,
   NWDPPsmRef              psmRef,
   pNWDPNSrvFQN            printerFqnPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPsmCancelShutdownPSM(
   NWDPAccessorRef         accessorRef,
   NWDPPsmRef              psmRef,
   pNWDPNameOrOid          reservedPtr   /* internal use only - pass NULL */
   );

 N_EXTERN_LIBRARY(nint)
NWDPPsmCreateMODObject(
   NWDPAccessorRef            accessorRef,
   NWDPPsmRef                 psmRef,
   pNWDPOid                   objectClassPtr,
   pNWDPObjectIdentification  objectIdentPtr,
   nbool                      force,
   pNWDPObjectIdentification  referenceObjectPtr,
   NWDPAttrSetRef             objectAttrSetRef,
   pNWDPAttrSetRef            resultAttrSetRefPtr,
   pNWDPASAVPRef              resultAvpRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPsmCreateRefBasedOnAddr(
   NWDPAccessorRef         accessorRef,
   pNWDPNetAddress         netAddrPtr,
   pNWDPPsmRef             psmRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPsmCreateRefBasedOnFQN(
   NWDPAccessorRef         accessorRef,
   pNWDPNSrvFQN            psmFqnPtr,
   pNWDPPsmRef             psmRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPsmDeleteMODObject(
   NWDPAccessorRef            accessorRef,
   NWDPPsmRef                 psmRef,
   pNWDPOid                   objectClassPtr,
   pNWDPObjectIdentification  objectIdentPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPsmDestroyRef(
   NWDPAccessorRef         accessorRef,
   pNWDPPsmRef             psmRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPsmGetConnectionStatus(
   NWDPAccessorRef            accessorRef,
   NWDPPsmRef                 psmRef
   );

 N_EXTERN_LIBRARY(nint)
NWDPPsmGetFQN(
   NWDPAccessorRef         accessorRef,
   NWDPPsmRef              psmRef,
   nuint                   sizeOfBuffer,
   pNWDPNSrvFQNBuffer      fqnBufferPtr,
   pnuint                  sizeOfResultPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPsmGetMODObjectAttrSet(
   NWDPAccessorRef            accessorRef,
   NWDPPsmRef                 psmRef,
   pNWDPOid                   objectClassPtr,
   pNWDPObjectIdentification  objectIdentPtr,          
   NWDPOidSetRef              requestedOidSetRef,
   pNWDPAttrSetRef            resultAttrSetRefPtr,
   pNWDPASAVPRef              avpRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPsmListMODObjects(
   NWDPAccessorRef             accessorRef,
   NWDPPsmRef                  psmRef,
   pNWDPOid                    objectClassPtr,
   pNWDPASSelector             selectorPtr,          
   NWDPOidSetRef               requestedOidSetRef,
   NWDPASMODObjectListCallback listCallback,
   nparam                      callerDefinedParam
   );

 N_EXTERN_LIBRARY(nint)
NWDPPsmListPAs(
   NWDPAccessorRef         accessorRef,
   NWDPPsmRef              psmRef,
   NWDPFilterRef           filterRef,
   NWDPPsmPAListCallback   listCallback,
   nparam                  callerDefinedParam
   );

 N_EXTERN_LIBRARY(nint)
NWDPPsmModifyMODObjectAttrs(
   NWDPAccessorRef            accessorRef,
   NWDPPsmRef                 psmRef,
   pNWDPOid                   objectClassPtr,
   pNWDPObjectIdentification  objectIdentPtr,          
   NWDPAttrSetRef             modifyRef,
   NWDPModifyOperatorEnum     modifyOperator
   );

 N_EXTERN_LIBRARY(nint)
NWDPPsmRemovePA(
   NWDPAccessorRef         accessorRef,
   NWDPPsmRef              psmRef,
   pnstr16                 paName16Ptr
   );

 N_EXTERN_LIBRARY(nint)
NWDPPsmShutdownPA(
   NWDPAccessorRef      accessorRef,
   NWDPPsmRef           psmRef,
   pnstr16              paName16Ptr,
   pNWDPNameOrOid       reservedPtr,   /* internal use only - pass NULL */
   NWDPShutdownType     shutdownType
   );

 N_EXTERN_LIBRARY(nint)
NWDPPsmShutdownPSM(
   NWDPAccessorRef         accessorRef,
   NWDPPsmRef              psmRef,
   pNWDPNameOrOid          reservedPtr,   /* internal use only - pass NULL */
   NWDPShutdownType        shutdownType
   );

 N_EXTERN_LIBRARY(nint)
NWDPPsmStartupPA(
   NWDPAccessorRef      accessorRef,
   NWDPPsmRef           psmRef,
   pnstr16              paName16Ptr,
   pNWDPNameOrOid       reservedPtr    /* internal use only - pass NULL */
   );

 N_EXTERN_LIBRARY(nint)
NWDPPsmValidateRef(
   NWDPAccessorRef         accessorRef,
	NWDPPsmRef              psmRef
   );

#else /* NWDP_PSM_H is defined. */

   #if defined(N_DEBUG)
      #error nwdp_psm.h has already been included.
   #endif /* N_DEBUG */

#endif /* NWDP_PSM_H */


