/*
//ͻ
// (c) 1995-1998 Novell, Inc.  All rights reserved.                         
//                                                                          
// THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND        
// TREATIES.                                                                
//                                                                          
// NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,          
// DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         
// EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED    
// WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        
//                                                                          
// ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT 
// THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.                         
//͹
// Source module name: NWDP_SEM.H                                           
//͹
// Library VeRsIoN=1.1.0                                                    
//ͼ
*/
/* Inclusion Control */
#if !defined( NWDP_SEM_H )
   #define NWDP_SEM_H

   /*
   // windows.h is required for the definition of CRITICAL_SECTION.
   */
   #if defined(N_PLAT_MSW4) && !defined(_INC_WINDOWS)
      #define	NOATOM						/* Atom Manager routines */
	   #define	NOCLIPBOARD                 /* Clipboard routines     */
	   #define	NOCOMM						/* to eliminate lint warnings */
	   #define	NODEFERWINDOWPOS			/* DeferWindowPos routines      */
	   #define	NOGDICAPMASKS				/* CC_*, LC_*, PC_*, CP_*, etc    */
	   #define	NOKANJI						/* Kanji support stuff             */
	   #define	NOMETAFILE					/* typedef METAFILEPICT        */
	   #define	NOMINMAX                    /* NO min(a,b) or max(a,b)       */
	   #define	NOOPENFILE					/* OpenFile(), OemToAnsi(), AnsiToOem()*/
	   #define	NOPROFILER					/* Profiler interface                   */
	   #define	NOSOUND						/* Sound Driver routines          */
	   #undef	OEMRESOURCE                 /* OEM Resource values            */
	   #undef	NOLSTRING					/* using lstrlen()                */

      #include <windows.h>
   #endif


   #if defined(N_PLAT_DOS)
      #define NWDPDeclareSemaphoreMac(__semaphore)
   #elif defined(N_PLAT_OS2)
      #define NWDPDeclareSemaphoreMac(__semaphore) nuint32 __semaphore;
   #elif defined(N_PLAT_MSW3)
      #define NWDPDeclareSemaphoreMac(__semaphore) nbool8  __semaphore;
   #elif defined(N_PLAT_MSW4)
      #define NWDPDeclareSemaphoreMac(__semaphore) \
                                          CRITICAL_SECTION __semaphore;
   #elif defined(N_PLAT_NLM)
      #define NWDPDeclareSemaphoreMac(__semaphore) nint32  __semaphore;
   #else
      #error nwdp_sem.h does not contain support for the current platform.
   #endif

#else /* NWDP_SEM_H is defined. */

   #if defined(N_DEBUG)
      #error nwdp_sem.h has already been included.
   #endif /* N_DEBUG */

#endif /* NWDP_SEM_H */

