/*
//ͻ
// (c) 1993 Novell, Inc.	All rights reserved.                              
//																								  
// THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND		  
// TREATIES.																					  
//																								  
// NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,			  
// DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         
// EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED	  
// WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        
//																								  
// ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT 
// THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.								  
//͹
// Source module name: NWPSCOM1.H														  
//ͼ
*/
#ifdef __cplusplus
extern "C" {
#endif

/*====================== Print Server Communications ======================*/
/*---------------------------------------------------------------
  The connType and connID fields are used to determine the context
  in which to run this library.	The connType and connID used by
  NWPSComLoginToPrintServer are used only to acquire rights.
  ---------------------------------------------------------------*/
N_EXTERN_LIBRARY(NWCCODE)
NWP1ComAttachToPrintServer(
  nuint32			connID,					/* Connection ID to file server		*/
  nuint				timeOut,             /* Number of seconds before timeout */
  pnstr8          pServerName,			/* Print server name                */
  NWPS_SPXID_HANDLE NWPTR spxID);		/* SPX Connection number				*/

#define NWPSComAttachToPrintServer(connType, connID, timeOut, pServerName, \
											  spxID)\
		  NWP1ComAttachToPrintServer(connID, timeOut, pServerName, spxID)

/*---------------------------------------------------------------
  The connType and connID fields are used only to acquire rights.
  The connType and connID used by NWPSComAttachToPrintServer are
  used to determine the context in which to run this library.
  ---------------------------------------------------------------*/
N_EXTERN_LIBRARY(NWCCODE)
NWP1ComLoginToPrintServer(
  nuint32				connID,				/* NDS Context handle					*/
  NWPS_SPXID_HANDLE	spxID,				/* SPX Connection number				*/
  pnuint             accessLevel);		/* Client's access level				*/

#define NWPSComLoginToPrintServer( connType, connID, spxID, accessLevel)\
		  NWP1ComLoginToPrintServer( connID, spxID, accessLevel)


#ifdef __cplusplus
}
#endif
