/*
//ͻ
// (c) 1993 Novell, Inc.	All rights reserved.                              
//																								  
// THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND		  
// TREATIES.																					  
//																								  
// NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,			  
// DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         
// EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED	  
// WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        
//																								  
// ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT 
// THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.								  
//͹
// Source module name: NWPS_DEF.H														  
//ͼ
*/
#ifndef NWPS_DEF_INC
#define NWPS_DEF_INC


/*
//  My definitions in case someone forgot theirs 
*/
#ifndef NWCCODE
	#define NWCCODE	nuint
#endif

#ifdef MAX_DN_BYTES
	#define NWPS_MAX_NAME_SIZE             MAX_DN_BYTES
#else
	#define NWPS_MAX_NAME_SIZE             514
#endif

#ifdef OBJECT_NAME_SIZE
	#define NWPS_BIND_NAME_SIZE				OBJECT_NAME_SIZE
#else
	#define NWPS_BIND_NAME_SIZE				48
#endif

#ifndef NWPASCAL
   #define NWPASCAL N_PASCAL
#endif /* NWPASCAL */

#ifndef NWFAR
   #define NWFAR N_FAR
#endif /* NWFAR */


#ifndef NWAPI
	#define NWAPI NWFAR NWPASCAL
#endif

#ifndef NWPTR
	#define NWPTR N_FAR *
#endif

#if defined(WIN32)
	#define NWPS_SPXID_HANDLE nptr
#else
	#define NWPS_SPXID_HANDLE nuint16
#endif

/*
// Fix for ntypes
*/
#if defined(N_PLAT_OS2)
#undef N_TYPEDEF_CALLBACK
#define N_TYPEDEF_CALLBACK( retType, typeName) \
   typedef retType ( * N_CALLBACK typeName)        
#endif



/*=====================================
	ConnectionType values used troughout
  =====================================*/
#define NWPS_BINDERY_SERVICE				0		/* ID is a connection id		*/
#define NWPS_DIRECTORY_SERVICE			1		/* ID is a context id			*/
#define NWPS_BINDERY_SERVICE_PRE_40    2		/* ID is a connection id		*/
/* This value is compile time only */
#define NWPS_BINDERY_SERVICE_ALL      -2		/* ID is a connection id		*/

/*====================
	 Maximum name sizes
  ====================*/
/*===================== PrintCon name sizes ===============================*/
#define NWPS_JOB_NAME_SIZE             32    /* 31 bytes and a '\0'			*/ 
#define NWPS_BANNER_NAME_SIZE          12    /* 12 bytes and a '\0'			*/ 
#define NWPS_BANNER_FILE_SIZE          12    /* 12 bytes and a '\0'			*/ 
#define NWPS_HEADER_FILE_SIZE          12    /* 12 bytes and a '\0'			*/ 

/*===================== PrintDef name sizes ===============================*/
#define NWPS_FORM_NAME_SIZE				12    /* 12 bytes and a '\0'			*/ 
#define NWPS_DEVI_NAME_SIZE				32    /* 32 bytes and a '\0'			*/ 
#define NWPS_MODE_NAME_SIZE				32    /* 32 bytes and a '\0'			*/ 
#define NWPS_FUNC_NAME_SIZE				32    /* 32 bytes and a '\0'			*/ 

/*================== Print Server Configuration Sizes =====================*/
#define NWPS_DESCRIPT_SIZE             128	/* matches Bind. prop. value	*/
#define NWPS_APPLE_NAME_SIZE				32    /* 32 bytes and a '\0'			*/ 
#define NWPS_APPLE_TYPE_SIZE				32    /* 32 bytes and a '\0'			*/ 
#define NWPS_APPLE_ZONE_SIZE				32    /* 32 bytes and a '\0'			*/ 
#define NWPS_UNIX_HOST_SIZE				255	/* 255 bytes and a '\0'       */ 
#define NWPS_UNIX_PRNT_SIZE				255	/* 255 bytes and a '\0'       */ 
#define NWPS_OTHER_SIZE                1024	/* bytes for NWPS_P_OTHER		*/

/*===========================
	 Maximum number of objects
  ===========================*/
/*================================================
	If -1 is used for a Printer or Form number,
	the first available number will be substituted.
  ================================================*/
#define NWPS_MAX_PRINTERS					255	/* numbered 0 - 254				*/
#define NWPS_MAX_FORMS						255	/* numbered 0 - 254				*/

/*==== GetFirst, GetNext, and EndNext require the following handle =========*/
typedef nptr	 NWPSListHandle;

#ifdef __cplusplus
extern "C" {
#endif

N_EXTERN_LIBRARY(void)
NWPSGetLibraryVersion(
  pnuint8  majorVersion,
  pnuint8  minorVersion,
  pnuint8  revisionLevel,
  pnuint8  betaReleaseLevel
);

#if defined(NWPS_CONN_TYPE)
   #if	NWPS_CONN_TYPE == NWPS_BINDERY_SERVICE
   #elif NWPS_CONN_TYPE == NWPS_DIRECTORY_SERVICE

N_EXTERN_LIBRARY(pnstr8)
NWPSFindNextPeriodInDSName(
   pnstr8	startHere
   );

   #elif NWPS_CONN_TYPE == NWPS_BINDERY_SERVICE_PRE_40
   #elif NWPS_CONN_TYPE == NWPS_BINDERY_SERVICE_ALL
   #endif
#else

N_EXTERN_LIBRARY(pnstr8)
NWPSFindNextPeriodInDSName(
   pnstr8	startHere
   );

#endif
	#ifdef __cplusplus
}
	#endif
#endif /* NWPS_DEF_INC */
