/*============================================================================
=  Novell Software Development Kit
=
=  Copyright (C) 1999-2001 Novell, Inc. All Rights Reserved.
=
=  This work is subject to U.S. and international copyright laws and treaties.
=  Use and redistribution of this work is subject  to  the  license  agreement
=  accompanying  the  software  development kit (SDK) that contains this work.
=  However, no part of this work may be revised and/or  modified  without  the
=  prior  written consent of Novell, Inc. Any use or exploitation of this work
=  without authorization could subject the perpetrator to criminal  and  civil
=  liability. 
=
=  Source(s): Novell Header
=
=  pshpack1.h
==============================================================================
*/

/*
** Note:
**
** The Novell NDK headers for NKS/LibC contain structures that are explicitly
** hand-packed for best use on the platform in question (usually IA32). To
** avoid the impredictability encountered when compiling with different
** compilers, these headers rely on 1-byte packing.
*/

/* this header sets packing to 1 for different compilers */

#if defined (_MSC_VER) && !defined(__BORLANDC__)
# if (_MSC_VER > 600)
#  pragma warning(disable:4103)
# endif
#elif defined (__BORLANDC__)
# if (__BORLANDC__ >= 0x500)
#  pragma warn -pck
# endif
#endif

/* save off the previous packing directive in a compiler specific way... */

#if defined (__BORLANDC__)
# if (__BORLANDC__ >= 0x500)
#  pragma pack(push)
# else
#  pragma option -a-
# endif
#elif defined (__WATCOMC__)
# if (__WATCOMC__ >= 1050)
#  pragma pack(push)
# endif
#elif defined (__MWERKS__)
# if (__MWERKS__ >= 0x2100)
#  pragma pack(push)
# endif
#elif defined(__ECC__) || defined(__ECPP__)
# pragma pack(push)
#elif defined (_MSC_VER) 
# if (_MSC_VER >= 900)
#  pragma pack(push)
# endif
#endif

/* turn on 1-byte packing... */
#pragma pack(1)
